      subroutine mkres(v,n1v,nrow,nv,r,n1r) 
c-------------------------------------------------------------------
c        forms resolution matrix for inverse obtained from a  
c  trucated singular value decomposition. 
c 
c  arguments- 
c    v   - nrow by nv array of right singular vectors from svd. 
c          vectors are assumed to be in the columns of v.  only 
c          nv vectors are used to form r.  (recall if nv = nrow 
c          then r will be an identity matrix) 
c    n1v - first dimension of v in calling program  
c    nrow- number of rows in v = number of columns in matrix  
c          that svd was performed on. 
c    nv  - number of singular vectors to keep.  this normally 
c          would correspond to the number of singular values kept 
c          in a generalized inverse generated by a trucated svd.
c    r   - matrix of size at least nrow by nrow to hold resolution
c          matrix.  (no size checks are made) 
c    n1r - first dimension of r in calling program. 
c 
c  language - fortran 
c  author   - gary l. pavlis
c  written  - may 1981
c-------------------------------------------------------------------
      real v(n1v,nv),r(n1r,nrow)
      do 200 j=1,nrow 
            do 100 i=j,nrow 
                  r(i,j) = sdot(nv,v(i,1),n1v,v(j,1),n1v) 
  100       continue  
  200 continue
      call cpltut(r,n1r,nrow) 
      return
      end 

c $Id: mkres.f,v 1.1.1.1 1997/04/12 04:18:31 danq Exp $ 
