sub add_headers {
	my( $Refguide_ref, $base_section, $Headers_ref ) = @_;
	my( %Headers ) = %$Headers_ref;

	foreach $section ( keys( %Headers ) ) {
		$layerref = $Refguide_ref;

		$total_section = $base_section . ":" . $section;
		$total_section =~ s/^://;

		@stack = split( /:/, $total_section );
		while( $layer = shift( @stack ) ) {
			if( ! defined( $layerref->{$layer} ) ) {
				$layerref->{$layer} = {};
				$layerref = $layerref->{$layer};
			} else {
				$layerref = $layerref->{$layer};
			}
		}

		$layerref->{"RGHeader"} = $Headers{$section};
	}
};

sub add_entries {
	my( $Refguide_ref, $base_section, $Entries_ref ) = @_;
	my( @Entries ) = @$Entries_ref;

	foreach $hashref ( @Entries ) {
		my( %Element ) = %$hashref;

		$layerref = $Refguide_ref;

		$total_section = $base_section . ":" . $Element{"section"};
		$total_section =~ s/^://;

		@stack = split( /:/, $total_section ) ; 
		while( $layer = shift( @stack ) ) {
			if( ! defined( $layerref->{$layer} ) ) {
				$layerref->{$layer} = {};
				$layerref = $layerref->{$layer};
			} else {
				$layerref = $layerref->{$layer};
			}
		}

	#	$layerref->{$Element{"command"}} = $hashref;
		push( @{$layerref->{"RGEntries"}}, $hashref );
	}
};

sub load_refguide {
	@pffiles = @_;

	my( %Refguide ) = ();

	foreach $pffile( @pffiles ) {
		my( $base_section ) = pfget( $pffile, "base_section" ) || "";
		my( $Entries_ref ) = pfget( $pffile, "Entries" ) || [];
		my( $Headers_ref ) = pfget( $pffile, "Headers" ) || {};
	
		&add_headers( \%Refguide, $base_section, $Headers_ref );
		&add_entries( \%Refguide, $base_section, $Entries_ref );
	}

	return \%Refguide;
}

1;
