use lib "$ENV{ANTELOPE}/contrib/data/perl" ;

require "getopts.pl" ;

use Datascope ;

require "load_refguide.pl";
require "fm_refguide.pl";

sub load_params {

	$doc_title = pfget( $refguide_pf, "doc_title" );
	$doc_version = pfget( $refguide_pf, "doc_version" );

	$omit_private = pfget( $refguide_pf, "omit_private" );
	$omit_deprecated = pfget( $refguide_pf, "omit_deprecated" );
	$label_deprecated = pfget( $refguide_pf, "label_deprecated" );

	@brtt_address = @{pfget( $refguide_pf, "brtt_address" )};
	@section_order = @{pfget( $refguide_pf, "section_order" )};
	%sort_orders = %{pfget( $refguide_pf, "sort_orders" )};

	%fm_params = %{pfget( $refguide_pf, "fm_params" )};
}

$program = `basename $0`;
chomp( $program );

if ( ! &Getopts('p:o:') || $#ARGV < 0 ) {

	die ( "Usage: $program [-p refguide_pffile] [-o refguide_name] " .
		"source_pffile [source_pffile ...]\n" ) ; 
} else {
	if( $opt_p ) {
		$refguide_pf = $opt_p;
	} else {
		$refguide_pf = $program;
	}
	if( $opt_o ) {
		$refguide_name = $opt_o;
	} else {
		$refguide_name = "refguide";
	}
}

%Refguide = %{&load_refguide( @ARGV )};

&load_params();

&begin_fm_refguide();
&fill_fm_refguide( \%Refguide );
&finalize_fm_refguide();
